import { Body, Controller, Get, Post, UseGuards } from '@nestjs/common';
import { CategoriesAccompagnementService } from '../services/categories-accompagnement.service';
import { CreateCategoriesAccompagnement } from '../dto/create-categoriesAccompagnement.dto';
import { CategoriesAccompagnement } from '../schemas/categoriesAccompagnement.schema';
import { JwtAuthGuard } from '../../auth/guards/jwt-auth.guard';
import { Roles } from '../../users/decorators/roles.decorator';
import { RolesGuard } from '../../users/guards/roles.guard';
import { ApiTags } from '@nestjs/swagger';

@ApiTags('categories')
@Controller('categories/categoriesAccompagnement')
export class CategoriesAccompagnementController {
  constructor(private readonly categoriesAccompagnementService: CategoriesAccompagnementService) {}

  @Post()
  @UseGuards(JwtAuthGuard, RolesGuard)
  @Roles('admin')
  public async create(@Body() createStructureDto: CreateCategoriesAccompagnement): Promise<CategoriesAccompagnement> {
    return this.categoriesAccompagnementService.create(createStructureDto);
  }

  @Get()
  public async findAll(): Promise<CategoriesAccompagnement[]> {
    return this.categoriesAccompagnementService.findAll();
  }
}
