import { Body, Controller, Get, Post, UseGuards } from '@nestjs/common';
import { CategoriesOthersService } from '../services/categories-others.service';
import { CreateCategoriesOthers } from '../dto/create-categoriesOthers.dto';
import { CategoriesOthers } from '../schemas/categoriesOthers.schema';
import { JwtAuthGuard } from '../../auth/guards/jwt-auth.guard';
import { Roles } from '../../users/decorators/roles.decorator';
import { RolesGuard } from '../../users/guards/roles.guard';
import { ApiTags } from '@nestjs/swagger';

@ApiTags('categories')
@Controller('categories/categoriesOthers')
export class CategoriesOthersController {
  constructor(private readonly categoriesOthersService: CategoriesOthersService) {}

  @Post()
  @UseGuards(JwtAuthGuard, RolesGuard)
  @Roles('admin')
  public async create(@Body() createStructureDto: CreateCategoriesOthers): Promise<CategoriesOthers> {
    return this.categoriesOthersService.create(createStructureDto);
  }

  @Get()
  public async findAll(): Promise<CategoriesOthers[]> {
    return this.categoriesOthersService.findAll();
  }
}
