import { getModelToken } from '@nestjs/mongoose';
import { Test, TestingModule } from '@nestjs/testing';
import { CreateCategoriesOthers } from '../dto/create-categoriesOthers.dto';
import { CategoriesOthersService } from './categories-others.service';

describe('CategoriesFormationsService', () => {
  let service: CategoriesOthersService;

  const mockCategoriesOthersModel = {
    create: jest.fn(),
    find: jest.fn(),
  };

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [],
      providers: [
        CategoriesOthersService,
        {
          provide: getModelToken('CategoriesOthers'),
          useValue: mockCategoriesOthersModel,
        },
      ],
    }).compile();

    service = module.get<CategoriesOthersService>(CategoriesOthersService);
  });

  it('should be defined', () => {
    expect(service).toBeDefined();
  });

  it('should create categorie accompagnement', async () => {
    const data: CreateCategoriesOthers = { name: 'test', modules: [{ id: 'Test', text: 'Text du test' }] };
    const _doc = { _id: '5fbb92ef80a5c257dc0161f2', ...data };
    mockCategoriesOthersModel.create.mockResolvedValueOnce(_doc);
    expect(await service.create(data)).toEqual(_doc);
  });

  it('should findAll structures', async () => {
    const data: CreateCategoriesOthers[] = [
      { name: 'test', modules: [{ id: 'Test', text: 'Text du test' }] },
      { name: 'test2', modules: [{ id: 'Test2', text: 'Text du test test 2' }] },
    ];
    mockCategoriesOthersModel.find.mockResolvedValueOnce(data);
    expect(await service.findAll()).toEqual(data);
  });
});
