import { Db } from 'mongodb';
import { getDb } from '../migrations-utils/db';

export const up = async () => {
  const db: Db = await getDb();
  const cursor = db.collection('users').find({});
  let document;
  while ((document = await cursor.next())) {
    await db.collection('users').updateOne({ _id: document._id }, [{ $set: { pendingStructuresLink: [] } }]);
  }
  console.log(`Update done : 'pendingStructuresLink' emptied in 'users' collection`);
};

export const down = async () => {
  // Nothing can be done since 'pendingStructuresLink' cannot be filled again with previously deleted values
  console.log(`Downgrade done`);
};
