import { getModelToken } from '@nestjs/mongoose';
import { Test, TestingModule } from '@nestjs/testing';
import { ParametersController } from './parameters.controller';
import { ParametersService } from './parameters.service';
import { Parameters } from './schemas/parameters.schema';

describe('ParametersController', () => {
  let controller: ParametersController;

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        ParametersService,
        {
          provide: getModelToken('Parameters'),
          useValue: Parameters,
        },
      ],
      controllers: [ParametersController],
    }).compile();

    controller = module.get<ParametersController>(ParametersController);
  });

  it('should be defined', async () => {
    expect(controller).toBeDefined();
  });

  it('should get parameters', async () => {
    const result = { lockdownInfoDisplay: false };
    jest.spyOn(controller, 'getParameters').mockImplementation(async (): Promise<Parameters> => result);
    expect(await controller.getParameters()).toBe(result);
  });

  it('should set lockdownInfoDisplay', async () => {
    const result = { lockdownInfoDisplay: false };
    jest
      .spyOn(controller, 'setParameterLockdownInfoDisplay')
      .mockImplementation(async (): Promise<Parameters> => result);
    const lockdownInfoDisplayValue = { lockdownInfoDisplay: false };
    expect(await controller.setParameterLockdownInfoDisplay(lockdownInfoDisplayValue)).toBe(result);
  });
});
