import { Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { ParametersController } from './parameters.controller';
import { ParametersService } from './parameters.service';
import { Parameters, ParametersSchema } from './schemas/parameters.schema';

@Module({
  imports: [MongooseModule.forFeature([{ name: Parameters.name, schema: ParametersSchema }])],
  controllers: [ParametersController],
  providers: [ParametersService],
})
export class ParametersModule {}
