import { getModelToken } from '@nestjs/mongoose';
import { Test, TestingModule } from '@nestjs/testing';
import { mockParametersModel } from '../../test/mock/services/parameters.mock.service';
import { IParameters } from './interface/parameters.interface';
import { ParametersService } from './parameters.service';
import { Parameters } from './schemas/parameters.schema';

describe('ParametersService', () => {
  let service: ParametersService;

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        ParametersService,
        {
          provide: getModelToken(Parameters.name),
          useValue: mockParametersModel,
        },
      ],
    }).compile();

    service = module.get<ParametersService>(ParametersService);
  });

  it('should be defined', () => {
    expect(service).toBeDefined();
  });

  it('should get parameters', async () => {
    const result: IParameters = { lockdownInfoDisplay: false } as IParameters;
    jest.spyOn(service, 'getParameters').mockImplementation(async (): Promise<Parameters> => result);
    expect(await service.getParameters()).toBe(result);
  });

  it('should set Parameter LockdownInfoDisplay', async () => {
    const result: IParameters = { lockdownInfoDisplay: false } as IParameters;
    jest.spyOn(service, 'setParameterLockdownInfoDisplay').mockImplementation(async (): Promise<Parameters> => result);
    expect(await service.setParameterLockdownInfoDisplay(false)).toBe(result);
  });
});
