import { Module } from '@nestjs/common';
import { MongooseModule } from '@nestjs/mongoose';
import { StructuresModule } from '../structures/structures.module';
import { UsersModule } from '../users/users.module';
import { PersonalOffersController } from './personal-offers.controller';
import { PersonalOffersService } from './personal-offers.service';
import { PersonalOffer, PersonalOfferSchema } from './schemas/personal-offer.schema';

@Module({
  imports: [
    MongooseModule.forFeature([{ name: PersonalOffer.name, schema: PersonalOfferSchema }]),
    StructuresModule,
    UsersModule,
  ],
  controllers: [PersonalOffersController],
  providers: [PersonalOffersService],
})
export class PersonalOffersModule {}
