import { HttpException, HttpStatus } from '@nestjs/common';

export class NewsletterServiceMock {
  findAll() {
    return [
      {
        _id: '607063e22b016303ad97f367',
        email: 'xavier@mii.fr',
        createdAt: '2021-04-09T10:14:01.939Z',
        updatedAt: '2021-04-09T10:14:01.939Z',
      },
      {
        _id: '607063e22b016303ad97f368',
        email: 'paula.dubois@mii.com',
        createdAt: '2021-04-09T10:14:01.939Z',
        updatedAt: '2021-04-09T10:14:01.939Z',
      },
      {
        _id: '607063e22b016303ad97f369',
        email: 'a@a.com',
        createdAt: '2021-04-09T10:14:01.939Z',
        updatedAt: '2021-04-09T10:14:01.939Z',
      },
    ];
  }

  searchNewsletterSubscription(search: string) {
    if (search === 'a@a.com') {
      return [
        {
          _id: '607063e22b016303ad97f369',
          email: 'a@a.com',
          createdAt: '2021-04-09T10:14:01.939Z',
          updatedAt: '2021-04-09T10:14:01.939Z',
        },
      ];
    }
    return [];
  }

  countNewsletterSubscriptions() {
    return new Promise((resolve) => {
      resolve(246);
    });
  }

  newsletterUnsubscribe(email: string) {
    if (email === 'test@test.com') {
      throw new HttpException('Invalid  email', HttpStatus.BAD_REQUEST);
    }
    return {
      _id: '607063e22b016303ad97f397',
      email: 'a@a.com',
      createdAt: '2021-04-09T10:14:01.939Z',
      updatedAt: '2021-04-09T10:14:01.939Z',
    };
  }
}
