import { HttpException, HttpStatus } from '@nestjs/common';
import { PersonalOffer, PersonalOfferDocument } from '../../../src/personal-offers/schemas/personal-offer.schema';
import { StructureDocument } from '../../../src/structures/schemas/structure.schema';

export class StructuresServiceMock {
  findOne(id) {
    if (id === '6093ba0e2ab5775cfc01ed3e') {
      return {
        _id: '6093ba0e2ab5775cfc01ed3e',
        coord: [4.8498155, 45.7514817],
        equipmentsAndServices: ['wifiEnAccesLibre'],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: [],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:38.000Z'),
        __v: 0,
      };
    }

    if (id === '6903ba0e2ab5775cfc01ed4d') {
      return {
        _id: '6903ba0e2ab5775cfc01ed4d',
        structureType: null,
        digitalCultureSecurity: ['2', '5', '9', '28', '34', '39', '42', '51', '52', '54', '65', '96', '97', '98'],
        parentingHelp: ['3', '22', '82', '94'],
        socialAndProfessional: ['6', '20', '66', '67', '68', '69', '124', '125', '127'],
        accessRight: ['84', '85', '86', '87', '88', '89', '93', '95'],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        proceduresAccompaniment: ['cpam', 'impots', 'carsat', 'poleEmploi'],
        publics: ['toutPublic'],
        labelsQualifications: ['passNumerique', 'espacePublicNumeriqueepn'],
        accessModality: ['accesLibre', 'telephoneVisio', 'surRdv'],
        freeWorkShop: false,
        createdAt: new Date('2020-11-16T09:30:00.000Z'),
        updatedAt: new Date('2020-11-16T09:30:00.000Z'),
        structureName: "L'Atelier Numérique",
        description:
          "L'Atelier Numérique est l'Espace Public Numérique des Centres Sociaux de Rillieux-la-Pape, ayant pour mission la médiation numérique pour toutes et tous.",
        lockdownActivity:
          'accesLibres, permanences numériques téléphoniques, cours et ateliers à distance, formations professionnelles.',
        contactPhone: '',
        contactMail: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        pmrAccess: true,
        exceptionalClosures: '',
        jaccompagneLesUsagersDansLeursDemarchesEnLigne: true,
        publicsAccompaniment: [],
        autresAccompagnements: '',
        equipmentsAndServices: ['ordinateurs', 'tablettes'],
        nbComputers: 16,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        hours: {
          monday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          tuesday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          wednesday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          thursday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          friday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
            ],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        __v: 0,
        address: {
          numero: '30 bis',
          street: 'Avenue Leclerc',
          commune: 'Rillieux-la-Pape',
        },
        coord: [4.9036773, 45.8142196],
        accountVerified: true,
        linkedin: null,
        nbScanners: 1,
        otherDescription: null,
        personalOffers: [],
      };
    }

    return null;
  }

  deleteOne(id) {
    if (id === '6903ba0e2ab5775cfc01ed4d') {
      return {
        _id: '6903ba0e2ab5775cfc01ed4d',
        structureType: null,
        digitalCultureSecurity: ['2', '5', '9', '28', '34', '39', '42', '51', '52', '54', '65', '96', '97', '98'],
        parentingHelp: ['3', '22', '82', '94'],
        socialAndProfessional: ['6', '20', '66', '67', '68', '69', '124', '125', '127'],
        accessRight: ['84', '85', '86', '87', '88', '89', '93', '95'],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        equipmentsAndServices: ['ordinateurs', 'imprimantes'],
        proceduresAccompaniment: ['cpam', 'impots', 'carsat', 'poleEmploi'],
        publics: ['toutPublic'],
        labelsQualifications: ['passNumerique', 'espacePublicNumeriqueepn'],
        accessModality: ['accesLibre', 'telephoneVisio', 'surRdv'],
        freeWorkShop: false,
        createdAt: new Date('2020-11-16T09:30:00.000Z'),
        updatedAt: new Date('2020-11-16T09:30:00.000Z'),
        structureName: "L'Atelier Numérique",
        description:
          "L'Atelier Numérique est l'Espace Public Numérique des Centres Sociaux de Rillieux-la-Pape, ayant pour mission la médiation numérique pour toutes et tous.",
        lockdownActivity:
          'accesLibres, permanences numériques téléphoniques, cours et ateliers à distance, formations professionnelles.',
        contactPhone: '',
        contactMail: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        pmrAccess: true,
        exceptionalClosures: '',
        jaccompagneLesUsagersDansLeursDemarchesEnLigne: true,
        publicsAccompaniment: [],
        autresAccompagnements: '',
        nbComputers: 16,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        hours: {
          monday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          tuesday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          wednesday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          thursday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
              {
                closing: '17:00',
                opening: '13:30',
              },
            ],
          },
          friday: {
            open: true,
            time: [
              {
                closing: '12:30',
                opening: '9:00',
              },
            ],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        __v: 0,
        address: {
          numero: '30 bis',
          street: 'Avenue Leclerc',
          commune: 'Rillieux-la-Pape',
        },
        coord: [4.9036773, 45.8142196],
        accountVerified: true,
        linkedin: null,
        nbScanners: 1,
        otherDescription: null,
        personalOffers: [],
      };
    }

    throw new HttpException('Invalid structure id', HttpStatus.BAD_REQUEST);
  }

  findAll() {
    return [
      {
        _id: '6093ba0e2ab5775cfc01abce',
        coord: [4.8498155, 45.7514817],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        equipmentsAndServices: ['ordinateurs', 'imprimantes'],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      },
      {
        _id: '6093ba0e2ab5775cfc01fffe',
        coord: [4.8498155, 45.7514817],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        equipmentsAndServices: ['ordinateurs', 'imprimantes'],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      },
    ];
  }

  findAllUnclaimed() {
    return [
      {
        _id: '6093ba0e2ab5775cfc01abcd',
        coord: [4.8498155, 45.7514817],
        equipmentsAndServices: ['wifiEnAccesLibre'],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: [],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      },
      {
        _id: '6093ba0e2ab5775cfc01ffff',
        coord: [4.8498155, 45.7514817],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        equipmentsAndServices: ['ordinateurs', 'imprimantes'],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      },
    ];
  }

  findAllFormated() {
    return [
      {
        _id: '6093ba0e2ab5775cfc01abcd',
        coord: [4.8498155, 45.7514817],
        equipmentsAndServices: ['wifiEnAccesLibre'],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: [],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        personalOffers: [],
        dataShareConsentDate: '2022-03-01T09:00:00.000Z',
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      },
      {
        _id: '6093ba0e2ab5775cfc01ffff',
        coord: [4.8498155, 45.7514817],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        equipmentsAndServices: ['ordinateurs', 'imprimantes'],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        personalOffers: [],
        dataShareConsentDate: '2022-03-01T09:00:00.000Z',
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      },
    ];
  }

  update() {
    return {
      _id: '6093ba0e2ab5775cfc01ed3e',
      coord: [4.8498155, 45.7514817],
      digitalCultureSecurity: [],
      parentingHelp: [],
      socialAndProfessional: [],
      accessRight: [],
      baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
      equipmentsAndServices: ['ordinateurs', 'imprimantes'],
      proceduresAccompaniment: [],
      publicsAccompaniment: [],
      publics: ['adultes'],
      labelsQualifications: [],
      accessModality: ['telephoneVisio'],
      structureType: null,
      structureName: 'a',
      description: null,
      lockdownActivity: null,
      address: {
        numero: null,
        street: 'Rue Alphonse Daudet',
        commune: 'Lyon 7ème Arrondissement',
      },
      contactMail: '',
      contactPhone: '',
      website: '',
      facebook: null,
      twitter: null,
      instagram: null,
      linkedin: null,
      hours: {
        monday: {
          open: false,
          time: [],
        },
        tuesday: {
          open: false,
          time: [],
        },
        wednesday: {
          open: false,
          time: [],
        },
        thursday: {
          open: false,
          time: [],
        },
        friday: {
          open: false,
          time: [],
        },
        saturday: {
          open: false,
          time: [],
        },
        sunday: {
          open: false,
          time: [],
        },
      },
      pmrAccess: false,
      exceptionalClosures: null,
      otherDescription: null,
      nbComputers: 1,
      nbPrinters: 1,
      nbTablets: 1,
      nbNumericTerminal: 1,
      nbScanners: 1,
      freeWorkShop: false,
      accountVerified: true,
      createdAt: new Date('2021-05-06T09:42:38.000Z'),
      updatedAt: new Date('2021-05-06T09:42:50.000Z'),
      __v: 0,
    };
  }

  async getAllUserCompletedStructures(users: any[]): Promise<any[]> {
    return [];
  }

  async addPersonalOffer(
    structureId: string,
    personalOfferDocument: PersonalOfferDocument
  ): Promise<StructureDocument> {
    if (structureId === '6093ba0e2ab5775cfc01ed3e') {
      const personalOffer: PersonalOffer = { ...personalOfferDocument } as PersonalOffer;
      return {
        _id: '6093ba0e2ab5775cfc01ed3e',
        coord: [4.8498155, 45.7514817],
        digitalCultureSecurity: [],
        parentingHelp: [],
        socialAndProfessional: [],
        accessRight: [],
        baseSkills: ['260', '1', '11', '38', '48', '74', '77'],
        equipmentsAndServices: ['ordinateurs', 'imprimantes'],
        proceduresAccompaniment: [],
        publicsAccompaniment: [],
        publics: ['adultes'],
        labelsQualifications: [],
        accessModality: ['telephoneVisio'],
        structureType: null,
        structureName: 'a',
        description: null,
        lockdownActivity: null,
        address: {
          numero: null,
          street: 'Rue Alphonse Daudet',
          commune: 'Lyon 7ème Arrondissement',
        },
        contactMail: '',
        contactPhone: '',
        website: '',
        facebook: null,
        twitter: null,
        instagram: null,
        linkedin: null,
        hours: {
          monday: {
            open: false,
            time: [],
          },
          tuesday: {
            open: false,
            time: [],
          },
          wednesday: {
            open: false,
            time: [],
          },
          thursday: {
            open: false,
            time: [],
          },
          friday: {
            open: false,
            time: [],
          },
          saturday: {
            open: false,
            time: [],
          },
          sunday: {
            open: false,
            time: [],
          },
        },
        pmrAccess: false,
        exceptionalClosures: null,
        otherDescription: null,
        nbComputers: 1,
        nbPrinters: 1,
        nbTablets: 1,
        nbNumericTerminal: 1,
        nbScanners: 1,
        freeWorkShop: false,
        accountVerified: true,
        personalOffers: [personalOffer],
        createdAt: new Date('2021-05-06T09:42:38.000Z'),
        updatedAt: new Date('2021-05-06T09:42:50.000Z'),
        __v: 0,
      } as StructureDocument;
    }
    if (personalOfferDocument._id === 'unIdQuiExisteDeja') {
      throw new HttpException('Personal offer already exist in the structure', HttpStatus.BAD_REQUEST);
    }
    throw new HttpException('Structure not found for the personal offer attachment', HttpStatus.BAD_REQUEST);
  }
}
